<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Document</title>
    <script src="https://cdn.jsdelivr.net/npm/vue/dist/vue.js"></script>
</head>
<body>
    <div id="app_1">
        <my-component-1></my-component-1>

        <!-- 등록되어있지 않기 때문에 출력되지 않는다. -->
        <my-component-2></my-component-2>
    </div>

    <div id="app_2">
        <!-- html쪽에서는 모든 식별자를 소문자, 케밥 케이스로 참조해야 한다. -->
        <myComp2 mainName="요건" subName="안됨"></my-comp2>
        <my-comp2 main-name="김동률" sub-name="Kim"></my-comp2>
        <my-comp-2 main-name="배성재" sub-name="Bae"></my-comp-2>

        <!-- is 속성으로 컴포넌트를 사용할 경우 카멜 케이스로도 참조할 수 있다 -->
        <div is="myComp2" main-name="강동원" sub-name="Kang"></div>
    </div>

    <script>
        // Vue 전역에서 사용할 수 있는 컴포넌트를 등록한다.
        // 컴포넌트의 이름은 HTML 스펙에서 강제하는 소문자, 케밥(-) 기법을 따르지 않아도 되지만
        // 그래도 따라주는게 좋다고 오피셜에서는 말하고 있다.
        let myComponent1 = {
            template: `<div>Hello world</div>`
        };

        let myComponent2 = {
            template: `
                <div>
                    <!-- 글로벌 컴포넌트이기 때문에 다른 컴포넌트에서도 접근 가능 -->
                    <my-component-1></my-component-1>
                    <p>{{mainName}}</p>
                    <button @click="swapName">Click</button>
                </div>`,
            data() {
                return {
                    mainName: "홍길동",
                    subName: "Hong Gil Dong",
                }
            },
            methods: {
                swapName() {
                    [this.mainName, this.subName] = [this.subName, this.mainName];
                },
            },
            // props: ["mainName", "subName"],
            props: {
                mainName: {
                    type: String, // 타입 여러개 설정하려면 [String, Number] 이런식으로 배열로
                    default: "홍길동", // 기본값 설정, type이 오브젝트나 배열일 경우 함수형식으로 구현해야 함
                },
                subName: {
                    type: String,
                    default: "Hong",
                },
            },
        };

        new Vue({
            el: "#app_1",
            components: {
                'my-component-1': myComponent1,
            }
        });

        new Vue({
            el: "#app_2",
            components: {
                'myComp2': myComponent2,
            }
        });
    </script>
</body>
</html>